## gftl-shared 1.0.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

# Note: the CMake project name is spelled slightly different than the
# git project.  This is to allow superprojects to use an environment
# variable to find gFTL-shared with find_package().  Env variables
# cannot have hyphens, whereas both git and cmake do allow hyphens in
# names.  Unfortunately, I learned the intricacies of find_package() a
# bit late in the game, and am trying to avoid relocating the git repo.
#
# Names/paths that are derived from the CMake project will all have
# "GFTL_SHARED" as their base name (and all caps).  Targets such as
# the library gftl-shared retain the hyphen (and lower case)
project (GFTL_SHARED
  VERSION 1.0.7
  LANGUAGES Fortran)


# Most users of this software do not (should not?) have permissions to
# install in the cmake default of /usr/local (or equiv on other os's).
# Below, the default is changed to a directory within the build tree
# unless the user explicitly sets CMAKE_INSTALL_PREFIX in the cache.
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set (CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/installed" CACHE PATH "default install path" FORCE )
endif()


if (POLICY CMP0076)
  cmake_policy(SET CMP0076 NEW)
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(CMAKE_MODULE_PATH "${GFTL_SHARED_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include(${CMAKE_Fortran_COMPILER_ID} RESULT_VARIABLE found)
include(check_intrinsic_kinds RESULT_VARIABLE found)

add_subdirectory (extern)
add_subdirectory (src)

configure_file (GFTL_SHAREDConfig-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/GFTL_SHAREDConfig-version.cmake @ONLY)
configure_file (GFTL_SHAREDConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/GFTL_SHAREDConfig.cmake @ONLY)

set (top_dir GFTL_SHARED-${GFTL_SHARED_VERSION_MAJOR}.${GFTL_SHARED_VERSION_MINOR})
install (
  FILES ${CMAKE_CURRENT_BINARY_DIR}/GFTL_SHAREDConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/GFTL_SHAREDConfig-version.cmake
  DESTINATION "${top_dir}/cmake")

# The following is needed for external projects using *nix make when
# parent project builds gFTL-shared as a subproject.
set (GFTL_SHARED_TOP_DIR "${CMAKE_INSTALL_PREFIX}/${top_dir}" CACHE PATH "")
configure_file (GFTL_SHARED.mk.in ${CMAKE_CURRENT_BINARY_DIR}/GFTL_SHARED.mk @ONLY)
install (
  FILES ${CMAKE_CURRENT_BINARY_DIR}/GFTL_SHARED.mk ${CMAKE_CURRENT_BINARY_DIR}/GFTL_SHARED.mk
  DESTINATION "${top_dir}/include")

=== extern/CMakeLists.txt ===
# We attempt to use find_package() first for each dependency.  But all
# dependencies are also available as submodules.

include(build_submodule)
build_submodule(gFTL PROJECT GFTL TARGET gftl)

add_library (extern-gftl-shared INTERFACE)
target_link_libraries (extern-gftl-shared INTERFACE gftl gftl-shared)

set (library_dest "lib/GFTL_SHARED-${GFTL_SHARED_VERSION_MAJOR}.${GFTL_SHARED_VERSION_MINOR}")
install (TARGETS extern-gftl-shared EXPORT GFTL_SHARED DESTINATION "${library_dest}")

=== src/CMakeLists.txt ===
set(CMAKE_Fortran_MODULE_DIRECTORY ${GFTL_SHARED_BINARY_DIR}/mod)

add_library(gftl-shared
  # Vector containers
  Integer32Vector.F90
  Integer64Vector.F90
  IntegerVector.F90

  Real32Vector.F90
  Real64Vector.F90
  RealVector.F90
  DoubleVector.F90

  Complex32Vector.F90
  Complex64Vector.F90
  ComplexVector.F90
  DoubleComplexVector.F90

  LogicalVector.F90
  StringVector.F90
  UnlimitedVector.F90

  # MapContainers
  StringInteger32Map.F90
  StringInteger64Map.F90
  StringIntegerMap.F90

  StringReal32Map.F90
  StringReal64Map.F90
  StringRealMap.F90
  StringDoubleMap.F90

  StringComplex32Map.F90
  StringComplex64Map.F90
  StringComplexMap.F90
  StringDoubleComplexMap.F90

  StringLogicalMap.F90
  StringStringMap.F90
  StringUnlimitedMap.F90





  Integer32Integer32Map.F90
  Integer32Integer64Map.F90
  Integer32IntegerMap.F90

  Integer32Real32Map.F90
  Integer32Real64Map.F90
  Integer32RealMap.F90
  Integer32DoubleMap.F90

  Integer32Complex32Map.F90
  Integer32Complex64Map.F90
  Integer32ComplexMap.F90
  Integer32DoubleComplexMap.F90

  Integer32LogicalMap.F90
  Integer32StringMap.F90
  Integer32UnlimitedMap.F90


  Integer64Integer32Map.F90
  Integer64Integer64Map.F90
  Integer64IntegerMap.F90

  Integer64Real32Map.F90
  Integer64Real64Map.F90
  Integer64RealMap.F90
  Integer64DoubleMap.F90

  Integer64Complex32Map.F90
  Integer64Complex64Map.F90
  Integer64ComplexMap.F90
  Integer64DoubleComplexMap.F90

  Integer64LogicalMap.F90
  Integer64StringMap.F90
  Integer64UnlimitedMap.F90



  IntegerInteger32Map.F90
  IntegerInteger64Map.F90
  IntegerIntegerMap.F90

  IntegerReal32Map.F90
  IntegerReal64Map.F90
  IntegerRealMap.F90
  IntegerDoubleMap.F90

  IntegerComplex32Map.F90
  IntegerComplex64Map.F90
  IntegerComplexMap.F90
  IntegerDoubleComplexMap.F90

  IntegerLogicalMap.F90
  IntegerStringMap.F90
  IntegerUnlimitedMap.F90


  
  )

if(_ISO_REAL128)
  target_sources(gftl-shared PRIVATE Real128Vector.F90)
  target_sources(gftl-shared PRIVATE Complex128Vector.F90)
  target_sources(gftl-shared PRIVATE StringReal128Map.F90)
  target_sources(gftl-shared PRIVATE StringComplex128Map.F90)
  target_sources(gftl-shared PRIVATE Integer32Real128Map.F90)
  target_sources(gftl-shared PRIVATE Integer32Complex128Map.F90)
  target_sources(gftl-shared PRIVATE Integer64Real128Map.F90)
  target_sources(gftl-shared PRIVATE Integer64Complex128Map.F90)
  target_sources(gftl-shared PRIVATE IntegerReal128Map.F90)
  target_sources(gftl-shared PRIVATE IntegerComplex128Map.F90)
endif()

if (_ISO_INT32 EQUAL _INT_DEFAULT_KIND)
  target_compile_definitions(gftl-shared PRIVATE _INT_DEFAULT_KIND_IS_INT32)
endif ()

if (_ISO_INT64 EQUAL _INT_DEFAULT_KIND)
  target_compile_definitions(gftl-shared PRIVATE _INT_DEFAULT_KIND_IS_INT64)
endif ()

if (_ISO_REAL32 EQUAL _REAL_DEFAULT_KIND)
  target_compile_definitions(gftl-shared PRIVATE _REAL_DEFAULT_KIND_IS_REAL32)
endif ()

if (_ISO_REAL64 EQUAL _REAL_DEFAULT_KIND)
  target_compile_definitions(gftl-shared PRIVATE _REAL_DEFAULT_KIND_IS_REAL64)
endif ()
      
if (_ISO_REAL64 EQUAL _DOUBLE_DEFAULT_KIND)
  target_compile_definitions(gftl-shared PRIVATE _DOUBLE_DEFAULT_KIND_IS_REAL64)
endif ()

if (_ISO_REAL128)
  if (_ISO_REAL128 EQUAL _DOUBLE_DEFAULT_KIND)
    target_compile_definitions(gftl-shared PRIVATE _DOUBLE_DEFAULT_KIND_IS_REAL128)
  endif ()
endif()

set (dest "GFTL_SHARED-${GFTL_SHARED_VERSION_MAJOR}.${GFTL_SHARED_VERSION_MINOR}")

target_include_directories (gftl-shared PUBLIC
  $<BUILD_INTERFACE:${GFTL_SHARED_BINARY_DIR}/mod>
  $<INSTALL_INTERFACE:${dest}/include>
  )

target_link_libraries (gftl-shared extern-gftl-shared)

add_executable (demo.x demo.F90)
target_link_libraries (demo.x gftl-shared)

install (DIRECTORY ${GFTL_SHARED_BINARY_DIR}/mod/ DESTINATION ${dest}/include)
install (TARGETS gftl-shared EXPORT GFTL_SHARED DESTINATION "${dest}/lib")
install (EXPORT GFTL_SHARED DESTINATION "${dest}/cmake")

=== debian/changelog ===
gftl-shared (1.0.7-2) unstable; urgency=low

  * Don't build demo executable

 -- Ole Streicher <olebole@debian.org>  Tue, 14 Jul 2020 15:47:07 +0200

gftl-shared (1.0.7-1) unstable; urgency=low

  * Initial release. Closes: #961669

 -- Ole Streicher <olebole@debian.org>  Tue, 26 May 2020 09:47:26 +0200

=== debian/control ===
Source: gftl-shared
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (=13),
               gfortran,
               gftl-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/gftl
Vcs-Git: https://salsa.debian.org/science-team/gftl.git
Homepage: https://github.com/Goddard-Fortran-Ecosystem/gFTL
Rules-Requires-Root: no

Package: gftl-shared-dev
Architecture: any
Depends: ${misc:Depends}
Description: Common gFTL containers of Fortran intrinsic types
 gFTL-shared provides gFTL containers for the Fortran intrinsic types.

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gftl-shared$1\.tar\.gz/ \
  https://github.com/Goddard-Fortran-Ecosystem/gFTL-shared/tags .*/v?(\d\S*)\.tar\.gz
